Bug 1830384 (CVE-2020-12691) - CVE-2020-12691 openstack-keystone: Credentials endpoint policy logic allows changing credential owner and target project ID
Summary: CVE-2020-12691 openstack-keystone: Credentials endpoint policy logic allows c...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2020-12691
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1832401 1831362 1831363 1831364 1831365
Blocks: 1830398
TreeView+ depends on / blocked
 
Reported: 2020-05-01 19:37 UTC by Laura Pardo
Modified: 2020-07-22 12:40 UTC (History)
22 users (show)

Fixed In Version: Keystone 15.0.1, Keystone 16.0.1
Doc Type: If docs needed, set a value
Doc Text:
A vulnerability was found in Keystone's EC2 credentials API. This flaw allows any authenticated user to create an EC2 credential for themselves for a project that they have a specified role, and then perform an update to the credential user and project, allowing them to masquerade as another user. This issue potentially allows the malicious user to act as the admin on a project another user has the admin role on, granting the user global admin privileges.
Clone Of:
Environment:
Last Closed: 2020-06-24 17:20:24 UTC


Attachments (Terms of Use)
propossed patch (5.17 KB, application/mbox)
2020-05-01 19:48 UTC, Laura Pardo
no flags Details
propossed patch (5.10 KB, application/mbox)
2020-05-01 19:49 UTC, Laura Pardo
no flags Details


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2020:2732 None None None 2020-06-24 12:36:24 UTC
Red Hat Product Errata RHSA-2020:3096 None None None 2020-07-22 12:11:58 UTC
Red Hat Product Errata RHSA-2020:3102 None None None 2020-07-22 12:40:13 UTC
Red Hat Product Errata RHSA-2020:3105 None None None 2020-07-22 12:40:26 UTC

Description Laura Pardo 2020-05-01 19:37:23 UTC
A vulnerability was found in Keystone's EC2 credentials API. Any authenticated user could create an EC2 credential for themselves for a project that they have a specified role on, then perform an update to the credential user and project, allowing them to masquerade as another user.
This potentially allows the malicious user to act as the admin on a project another user has the admin role on, which can effectively grant the user
global admin privileges.

Comment 1 Laura Pardo 2020-05-01 19:48:31 UTC
Created attachment 1683810 [details]
propossed patch

Created attachment 1683810 [details]
0001-Disable-altering-credential-owner-attributes.patch-train

Comment 2 Laura Pardo 2020-05-01 19:49:52 UTC
Created attachment 1683811 [details]
propossed patch

Created attachment 1683811 [details]
0001-Disable-altering-credential-owner-attributes.patch-master

Comment 4 msiddiqu 2020-05-01 21:38:13 UTC
References: 
 
https://launchpad.net/bugs/1872733

Comment 7 Nick Tait 2020-05-06 16:37:26 UTC
Created openstack-keystone tracking bugs for this issue:

Affects: openstack-rdo [bug 1832401]

Comment 10 Nick Tait 2020-05-07 19:48:37 UTC
External References:

https://security.openstack.org/ossa/OSSA-2020-004.html

Comment 15 Nick Tait 2020-05-14 01:11:08 UTC
Acknowledgments:

Name: kay (OpenStack)

Comment 16 errata-xmlrpc 2020-06-24 12:36:21 UTC
This issue has been addressed in the following products:

  Red Hat OpenStack Platform 13.0 (Queens)
  Red Hat OpenStack Platform 13.0 (Queens) for RHEL 7.6 EUS

Via RHSA-2020:2732 https://access.redhat.com/errata/RHSA-2020:2732

Comment 17 Product Security DevOps Team 2020-06-24 17:20:24 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2020-12691

Comment 18 errata-xmlrpc 2020-07-22 12:11:55 UTC
This issue has been addressed in the following products:

  Red Hat OpenStack Platform 10.0 (Newton)

Via RHSA-2020:3096 https://access.redhat.com/errata/RHSA-2020:3096

Comment 19 errata-xmlrpc 2020-07-22 12:40:10 UTC
This issue has been addressed in the following products:

  Red Hat OpenStack Platform 15.0 (Stein)

Via RHSA-2020:3102 https://access.redhat.com/errata/RHSA-2020:3102

Comment 20 errata-xmlrpc 2020-07-22 12:40:22 UTC
This issue has been addressed in the following products:

  Red Hat OpenStack Platform 16.0 (Train)

Via RHSA-2020:3105 https://access.redhat.com/errata/RHSA-2020:3105


Note You need to log in before you can comment on or make changes to this bug.